<?php
include('../include/templates.php');
$subtitle = 'Inscription serveur Jabber';
$pageauthor = ', Psykauze (psykauze@jabber.fr)';
$pagekeywords = 'jabber, xmpp, aide, francais, france, francophone';
top();
?>
			<p style="clear:both;"></p>
<?php
$error=False;
if (isset($_REQUEST['register'])) {
	//verification des info entrés
	require_once('./recaptchalib.php');
	$privatekey = '6LfBN_gSAAAAAD1PgJwE4qcmLsR0dmc2AtWqWZxG';
	$resp = recaptcha_check_answer ($privatekey,
									$_SERVER["REMOTE_ADDR"],
									$_REQUEST["recaptcha_challenge_field"],
									$_REQUEST["recaptcha_response_field"]);

	if (!$resp->is_valid) {
		// What happens when the CAPTCHA was entered incorrectly
		echo '<p class="error">Erreur de captcha (' . $resp->error . ')';
		$error = True;
	}
	if (!isset($_REQUEST['username'])){
		echo '<p class="error">Le nom d\'utilisateur n\'est pas spécifié</p>';
		$error=True;
	}
	if (!isset($_REQUEST['server'])){
		echo '<p class="error">Le nom du serveur n\'est pas spécifié</p>';
		$error=True;
	}
	if (!isset($_REQUEST['password']) || !isset($_REQUEST['password2'])){
		echo '<p class="error">Le mot de passe n\'est pas spécifié</p>';
		$error=True;
	} else {
		if ($_REQUEST['password'] != $_REQUEST['password2']) {
			echo '<p class="error">Les mots de passe ne correspondent pas</p>';
			$error=True;
		}
	}
	if (!$error) {
		// load the class.jabber.php
		require ("class.jabber.php") ;

		// load '$jabber' object
		$jabber = new Jabber ;

		// connect() variables
		$jabber->server = $_REQUEST['server'] ;
		$jabber->port = "5222" ;
		//$jabber->enable_logging= TRUE;

		// AccountRegistration() variables
		$jabber->username = $_REQUEST['username'] ;
		$jabber->password = $_REQUEST['password'] ;
		if (!$jabber->Connect()) {
			echo '<p class="error">Impossible de se connecter sur le serveur Jabber</p>';
			$error=True;
		}
		if (!$error) {
			$email=isset($_REQUEST['email'])?$_REQUEST['email']:NULL;
			$name=isset($_REQUEST['name'])?$_REQUEST['name']:NULL;
			$status = $jabber->AccountRegistration($email, $name) ;
			switch ($status) {
				case 1:
					echo '<p class="error">Le nom d\'utilisateur <em>'.htmlspecialchars($jabber->username).'</em> est déjà pris sur le serveur Jabber <em>'.htmlspecialchars($jabber->server).'</em></p>' ;
					$error=True;
					break ;

				case 2:
					echo '<p class="success">Le JID <em>'.htmlspecialchars($jabber->username).'@'.htmlspecialchars($jabber->server).'</em> a été créé avec succès. Vous pouvez dès à présent vous connecter en utilisant un <a href="https://wiki.jabberfr.org/Clients">client Jabber</a>.</p>' ;
					break ;

				case 3:
					echo '<p class="error">Le serveur Jabber <em>'.htmlspecialchars($jabber->server).'</em> n\'a pas répondu.</p>' ;
					$error=True;
					break ;

				case 406:
					echo '<p class="error">Non acceptable : Le nom d\'utilisateur est surement invalide (vide, trop long ou contient des caractères non autorisés)</p>';
					$error = True;
					break;

				default:
					echo '<p class="error">Code d\'erreur inconnu : \''.$status.'\'.</p>' ;
					$error=True;
					break ;
			}
			// sign off (if passwords match :p)
			$jabber->Disconnect() ;
		}
	}
}

if ((!isset($_REQUEST['register'])) || $error) {
	if (!$error){ ?>
			<p>Cet outil va vous permettre de vous créer un compte <a href="https://wiki.jabberfr.org/Jabber">Jabber</a>.</p> 
<?php } ?>
			<hr />
			<blockquote>
				<!-- JID's take the form of 'username@server.com'. For example, my JID is 'kirjava@jabber.org'.
				The maximum length for a JID is 255 characters. -->
				<form method="post" action="index.php">
					<p><label for="username"><span style="color:#f00">1.</span> Nom d'utilisateur&nbsp;:</label>
						<input type="text" size="20" id="username" name="username" maxlength="255"<?php if (isset($_REQUEST['username'])) echo ' value="'.$_REQUEST['username'].'"'; ?>/></p>
					<ul>
						<li>Ceci est le <em>nom d'utilisateur</em> que vous utiliserez pour vous identifier sur votre compte.</li>
						<li>Le nom d'utilisateur est insensible à la casse, <em>votrenom</em> est identique à <em>VotreNom</em>.</li>
						<li>Un nom d'utilisateur ne peut contenir <span style="text-decoration: underline;">aucun</span> de ces caractères&nbsp;: @ : ' " &lt; &gt; &amp;</li>
						<li>Certains serveurs limitent la taille du nom d'utilisateur à 16 caractères.</li>
					</ul>
					<p><label for="server"><span style="color:#f00">2.</span> Serveur Jabber&nbsp;:</label>
<?php
$sxml = simplexml_load_file('domains.xml');
if ($sxml == FALSE) {
	echo "Erreur : Impossible de récupérer la liste des serveurs";
}
?>
						<select name="server" id="server">
<?php
if ($sxml == TRUE) {
	$doms=array();
	foreach ($sxml->item as $item) {
		array_push($doms,strval($item['jid']));
	}
	if ((isset($_REQUEST['server'])) && (in_array($_REQUEST['server'],$doms))){
		$domaine = $_REQUEST['server'];
		$rand=-1;
	}
	else {
		$domaine = "";
		$rand = rand(0,count($doms)-1);
	}
	$i=0;
	print_r($doms);
	foreach($doms as $dom){
		echo '<option value="'.$dom.'"';
		if ($dom==$domaine || $rand == $i) {
			echo ' selected="selected"';
		}
		echo '>'.$dom.'</option>
		';
		$i++;
	}
}
?>
						</select></p>
					<ul>
						<li>Vous pouvez utiliser certains services de serveurs autres que celui sur lequel vous êtes inscrit, comme par exemple les salons de discussions.</li>
						<li>Les serveurs proposés ici sont des serveurs faisant partis de la <a href="https://jabberfr.org/federation">fédération JabberFR</a>, JabberFR n'étant pas un serveur Jabber, mais un regroupement de serveurs autour des services comme le <a href="https://forum.jabberfr.org">forum</a> et le <a href="https://wiki.jabberfr.org">wiki</a>.</li>
					</ul>
					<p><label for="password"><span style="color:#f00">3.</span> Mot de passe&nbsp;:</label>
						<input type="password" size="20" id="password" name="password" maxlength="255" /></p> 
					<p><label for="password2">Vérification du mot de passe&nbsp;:</label>
						<input type="password" size="20" id="password2" name="password2" maxlength="255" /></p>
					<ul>
						<li>Ce mot de passe protège votre compte. Ne le divulguez à personne. 
								Personne d'autre que vous n'a besoin de votre mot de passe.</li>
						<li>Vous pouvez toujours utiliser votre client Jabber pour changer votre mot de passe.</li>
						<li>Vous pouvez prendre soin d'indiquer votre adresse e-mail dans les informations personnelles de votre compte afin de pouvoir vous faire envoyer votre mot de passe à l'aide du <a href="https://im.apinc.org/outils/password.php">formulaire</a>,  autrement il vous sera impossible de récupérer le mot de passe en cas d'oubli.</li>
					</ul>
					<p style="padding-top:20px;"><label for="register"><span style="color:#f00">4.</span> Valider le captcha</p>
					<script type="text/javascript" src="https://www.google.com/recaptcha/api/challenge?k=6LfBN_gSAAAAADv_5XpffA4l7Xdif9dgwCyXDFfh"></script>
					<noscript>
						<iframe src="https://www.google.com/recaptcha/api/noscript?k=6LfBN_gSAAAAADv_5XpffA4l7Xdif9dgwCyXDFfh" height="300" width="500" frameborder="0"></iframe><br>
						<textarea name="recaptcha_challenge_field" rows="3" cols="40"></textarea>
						<input type="hidden" name="recaptcha_response_field" value="manual_challenge">
					</noscript>
					<p style="padding-top:20px;"><label for="register"><span style="color:#f00">5.</span> Créer le compte&nbsp;: </label><input type="submit" value="Créer le compte" name="register" id="register"/></p>
				</form>
			</blockquote>
			<hr />
<?php } ?>
			<a href="http://jabberpowered.org/"><img src="jabber-powered.png" alt="JabberPowered" height="18" width="123" style="border:0; text-align:right;" /></a>
			| Propulsé par <a href="https://php.net/">PHP</a> et <a href="http://freecode.com/projects/classjabberphp/">class.jabber.php</a> | <a href="legal.php">Infos Légales</a> | Fait par <a href="http://hblug.debian.co.nz/kirjava/">kirjava</a> | <a href="https://xmpp.org/">xmpp.org</a> |
		</div>
<?php bottom(); ?>
